!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! -*- Mode: F90 -*- !!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!! ping_pong_1.f90 --- TP2 : point-to-point communications :
!!                           the process 0 send a message to the process 1
!! 
!! Author          : Denis GIROU (CNRS/IDRIS - France) <Denis.Girou@idris.fr>
!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

program ping_pong_1
  USE MPI
  implicit none

  integer, dimension(MPI_STATUS_SIZE) :: status
  integer, parameter                  :: nb_values=1000,tag=99
  integer                             :: rank,code
  ! Kind for double precision
  integer, parameter                   :: dp = selected_real_kind(15,307)
  real(kind=dp), dimension(nb_values)  :: values
  integer                              :: typedp

  call MPI_INIT(code)

  call MPI_COMM_RANK(MPI_COMM_WORLD,rank,code)
  call MPI_TYPE_CREATE_F90_REAL(15,307,typedep,code)

  if (rank == 0) then
    call random_number(values)
    call MPI_SEND(values,nb_values,typedp,1,tag, &
                  MPI_COMM_WORLD,code)
  elseif (rank == 1) then
    call MPI_RECV(values,nb_values,typedp,0,tag, &
                  MPI_COMM_WORLD,status,code)
    print ('("Me, process 1, received ",i4," values (last = ", &
           & f4.2,") from process 0.")'), nb_values,values(nb_values)
  end if

  call MPI_FINALIZE(code)

end program ping_pong_1
