!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! -*- Mode: F90 -*- !!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!! ping_pong_2.f90 --- TP2 : point-to-point communications  : ping-pong
!! 
!! Author          : Denis GIROU (CNRS/IDRIS - France) <Denis.Girou@idris.fr>
!! 
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

program ping_pong_2
  USE MPI
  implicit none

  integer, dimension(MPI_STATUS_SIZE) :: status
  integer, parameter                  :: nb_values=1000,tag=99
  integer                             :: rank,code
  ! Kind for double precision
  integer, parameter                   :: dp = selected_real_kind(15,307)
  real(kind=dp)                        :: time_begin,time_end
  real(kind=dp), dimension(nb_values)  :: values
  integer                              :: typedp

  call MPI_INIT(code)

  call MPI_COMM_RANK(MPI_COMM_WORLD,rank,code)
  call MPI_TYPE_CREATE_F90_REAL(15,307,typedp,code)

  if (rank == 0) then
    call random_number(values)
    time_begin=MPI_WTIME()
    call MPI_SEND(values,nb_values,typedp,1,tag, &
                  MPI_COMM_WORLD,code)
    call MPI_RECV(values,nb_values,typedp,1,tag, &
                  MPI_COMM_WORLD,status,code)
    time_end=MPI_WTIME()
    print ('("Me, process 0, sent and received ",i5, &
        & " values (last = ",f4.2,") from process 1", &
        & " in ",f8.6," seconds.")'), &
          nb_values,values(nb_values),time_end-time_begin
  elseif (rank == 1) then
    call MPI_RECV(values,nb_values,typedp,0,tag, &
                  MPI_COMM_WORLD,status,code)
    call MPI_SEND(values,nb_values,typedp,0,tag, &
                  MPI_COMM_WORLD,code)
  end if

  call MPI_FINALIZE(code)

end program ping_pong_2
