!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! -*- Mode: F90 -*- !!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!! transpose.f90  --- derived datatypes (type_transpose)
!!                    to transpose matrix
!!
!!
!! Author          : Isabelle DUPAYS (CNRS/IDRIS - France)
!!                   <Isabelle.Dupays@idris.fr>
!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


PROGRAM transpose
  USE MPI_F08
  IMPLICIT NONE
  INTEGER, PARAMETER                       :: nb_lines=5,nb_columns=4,&
                                              nb_lines_t=4,nb_columns_t=5,&
                                              tag=1000
  INTEGER                                  :: rank,size_real,i
  TYPE(MPI_Datatype)                       :: type_line,type_transpose
  REAL, DIMENSION(nb_lines,nb_columns)     :: A
  REAL, DIMENSION(nb_lines_t,nb_columns_t) :: AT
  INTEGER(kind=MPI_ADDRESS_KIND)           :: sizeDisplacement
  TYPE(MPI_Status)                         :: status


  !-- MPI init 
  CALL MPI_INIT()

  !-- Who I am
  CALL MPI_COMM_RANK(MPI_COMM_WORLD,rank)

  !-- AT matrix  initialisation 
  AT(:,:) = 0.

  !Size of the generic datatype MPI_REAL
 

  !Creation of the derived datatype type_line 
  !for one line of the A matrix
 

  !Creation of the derived datatype type_transpose to transpose the
  !A matrix nb_lines lines and nb_columns columns
 

  !Validation of the derived datatype type_transpose
 

  IF (rank == 0) THEN
    !Initialisation of the A matrix on the 0 process
    A(:,:) = RESHAPE( (/ (i,i=1,nb_lines*nb_columns) /), &
                      (/ nb_lines,nb_columns /) )

    PRINT *,'Matrice A'
    DO i=1,nb_lines
      PRINT *,A(i,:)
    END DO

    !Send A matrix to process 1 using the derived datatype type_transpose
    

  ELSE
    !Reception for the process 1 in AT matrix
    

    PRINT *,'Matrix transpose AT'
    DO i=1,nb_lines_t
      PRINT *,AT(i,:)
    END DO

  END IF

  ! Clean MPI types

  !MPI finalize
  CALL MPI_FINALIZE()

END PROGRAM transpose
